#include "process.h"

int main( int argc, char* argv[] )
{
  byte* source = NULL;
  byte* target = NULL;
  int   length =    0;

  if( argc != 3 )
  {
    printf( "usage : process [-f <file> | -s <string>]\n" );
    exit( 0 );
  }

  if     ( strcmp( argv[ 1 ], "-f" ) == 0 )
  {
    FILE* file = fopen( argv[ 2 ], "r" );

    fseek( file, 0, SEEK_END );
    length = ftell( file );
    fseek( file, 0, SEEK_SET );

    source = ( byte* )( malloc( length ) );

    for( int i = 0; i < length; i++ )
    {
      source[ i ] = fgetc( file );
    }
  }
  else if( strcmp( argv[ 1 ], "-s" ) == 0 )
  {
    source = ( byte* )(       ( argv[ 2 ] ) );
    length =          ( strlen( argv[ 2 ] ) );
  }

  lash_init();

  target = ( byte* )( malloc( lash_sizeof_dig() / 1 ) );

  lash_proc( target, source, length*1 );

  for( int i = 0; i < lash_sizeof_dig() / 1; i++ )
  {
    if( i != 0 )
      printf( " " );
    printf( "%02X", target[ i ] );
  }

  printf( "\n" );

  lash_fini();
}
