#ifndef __LASH_X86_BYTE_ALL_H
#define __LASH_X86_BYTE_ALL_H

static inline void comp( byte* r, byte* s )
{
  byte  t[ M ];
  byte* h     ;

  for( int i = 0; i < m; i++ )
  { 
    t[ i ] = r[ i ] ^ s[ i ];
  }

  h = H;

  for( int i = 0; i < ( m << 1 ); i++ )
  {
    byte b;

    if( i < m )
      b = r[ i - 0 ];
    else
      b = s[ i - m ];

    for( int j = 7; j >= 0; j-- ) // !!!
    {
      if( ( b >> j ) & 1 )
      {
        for( int k = 0; k < m; k++ )
          t[ k ] += h[ k ];
      }

      h += M;
    }
  }  

  memcpy( r, t, m );
}

#endif
